package io.zipcoder.interfaces;

import org.junit.Assert;
import org.junit.Test;

public class InstructorTest {

    @Test

    public void testImplementation(){

        Instructor instructor = new Instructor(2, "Dracula");

        Assert.assertTrue(instructor instanceof Teacher);
    }


    @Test
    public void testInheritance(){

        Instructor instructor = new Instructor(2, "Dracula");

        Assert.assertTrue(instructor instanceof Person);
    }

    @Test
    public void testTeach(){

        Instructor instructor = new Instructor(2,"Dracula");
        Student student = new Student(3,"Billy");

        instructor.teach(student, 5);

        double expected = 5;
        double actual = student.getTotalStudyTime();

        Assert.assertEquals(expected, actual, .01);

        instructor.teach(student, 12);

        double expected2 = 17;
        double actual2 = student.getTotalStudyTime();

        Assert.assertEquals(expected2, actual2, .01);
    }

    @Test

    public void testLecture(){

        Instructor instructor = new Instructor(2, "Dracula");

        Student billy = new Student(3, "Billy");
        Student sally = new Student(3, "Sally");
        Student sarah = new Student(3, "Sarah");

        Learner[] students = {billy, sally,sarah};

        instructor.lecture(students, 36);

        double expected = 12;
        double actual = billy.getTotalStudyTime();

        Assert.assertEquals(expected, actual, .01);

        instructor.lecture(students,72);

        double expected2 = 36;
        double actual2 = billy.getTotalStudyTime();

        Assert.assertEquals(expected2,actual2,.01);
    }
}

